from setuptools import setup, find_packages

setup(
    name = "Landsifier",
    version = "2.0.1",
    description = "A library for predicting the classes of landslides based on their topography",
    author = "Manan Kapoor, Kushanav Bhuyan, Kamal Rana",
    author_email = "manank1997@gmail.com, kushanav.bhuyan@phd.unipd.it, kamalrana520@gmail.com",
    url = 'https://github.com/manank1997/Landsifier-V2.0.0/',
    long_description = open('README.md').read(),
    long_description_content_type = "text/markdown",
    packages = find_packages(where="src"),
    package_dir = {"": "src"},
    install_requires=[
        'pillow',
        'cloudpickle',
        'gdal',
        'giotto-tda',
        'ipython',
        'joblib',
        'numpy',
        'matplotlib',
        'scipy',
        'shapely',
        'geopandas',
        'utm',
        'scikit-learn',
        'pyproj',
        'elevation',
        'pandas',
        'tqdm',
    ],
    python_requires = ">=3.8",
    include_package_data = True,
    classifiers = [
        "Programming Language :: Python :: 3.8",
        "Operating System :: OS Independent",
    ],
)